# coding: utf-8

# GPIO ライブラリをインポート
import RPi.GPIO as GPIO

# time ライブラリをインポート
import time

# ピン番号の割り当て方式を「コネクタのピン番号」に設定
GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)
# 使用するピン番号を代入
PIN = [15,18,16,22]
MASK = [0b1000, 0b0010, 0b0100, 0b0001]
SPEED=0.1

# 各ピンを出力ピンに設定
for i in range(len(PIN)):
    GPIO.setup(PIN[i], GPIO.OUT, initial=GPIO.HIGH)


# 出力信号パターンのリストを作成
SIG = [ 0b1000,
        0b1100,
        0b0100,
        0b0110,
        0b0010,
        0b0011,
        0b0001,
        0b1001 ]

# 例外を検出
try:
    # 無限ループ
    while True:
        # step で指定したステップ数までループ
        step_count=0
        while step_count < len(SIG):
            # 出力信号パターンを順番に出力
            for i in range(len(PIN)):
                GPIO.output(PIN[i], SIG[step_count] & MASK[i])  
            # 0.01 秒待つ
            time.sleep(SPEED)
            step_count=step_count+1
        
# キーボード例外を検出
except KeyboardInterrupt:
    # 何も処理しない
    pass

# GPIO を解放
GPIO.cleanup()
